// serverstatus.js
var error = 0;
var d = 0;
var server_status = new Array();
var urlParams = new URLSearchParams(window.location.search);
var pass=urlParams.get('pass')===null?"":urlParams.get('pass');
function timeSince(date) {
    if (date == 0)
        return "从未.";

    var seconds = Math.floor((new Date() - date) / 1000);
    var interval = Math.floor(seconds / 31536000);

    if (interval > 1)
        return interval + " 年前.";
    interval = Math.floor(seconds / 2592000);
    if (interval > 1)
        return interval + " 月前.";
    interval = Math.floor(seconds / 86400);
    if (interval > 1)
        return interval + " 日前.";
    interval = Math.floor(seconds / 3600);
    if (interval > 1)
        return interval + " 小时前.";
    interval = Math.floor(seconds / 60);
    if (interval > 1)
        return interval + " 分钟前.";
    /*if(Math.floor(seconds) >= 5)
        return Math.floor(seconds) + " seconds";*/
    else
        return "几秒前.";
}

function bytesToSize(bytes, precision, si) {
    var ret;
    si = typeof si !== 'undefined' ? si : 0;
    if (si != 0) {
        var kilobyte = 1000;
        var megabyte = kilobyte * 1000;
        var gigabyte = megabyte * 1000;
        var terabyte = gigabyte * 1000;
    } else {
        var kilobyte = 1024;
        var megabyte = kilobyte * 1024;
        var gigabyte = megabyte * 1024;
        var terabyte = gigabyte * 1024;
    }

    if ((bytes >= 0) && (bytes < kilobyte)) {
        return bytes + ' B';

    } else if ((bytes >= kilobyte) && (bytes < megabyte)) {
        ret = (bytes / kilobyte).toFixed(precision) + ' K';

    } else if ((bytes >= megabyte) && (bytes < gigabyte)) {
        ret = (bytes / megabyte).toFixed(precision) + ' M';

    } else if ((bytes >= gigabyte) && (bytes < terabyte)) {
        ret = (bytes / gigabyte).toFixed(precision) + ' G';

    } else if (bytes >= terabyte) {
        ret = (bytes / terabyte).toFixed(precision) + ' T';

    } else {
        return bytes + ' B';
    }
    if (si != 0) {
        return ret + 'B';
    } else {
        return ret + 'iB';
    }
}

function uptime() {

    $.getJSON("json/stats"+pass+".json", function(result) {
        var up_num = 0
        var down_num = 0
        var num = result.servers.length
        let loac = result.servers.slice()
        document.getElementById("num").innerHTML=num

        result.servers = result.servers.sort((x, y) => {
           return x.name.localeCompare(y.name);
        });
        //location 排序
        result.location = loac.sort((x, y) => {
            return x.location.localeCompare(y.location);
        });

        result.servers = result.servers.sort((x, y) => {
            if (x.online4 == true) {
                return 1
            }
            return -1;

        });
        //console.log(result.servers)
        var shstr ='<div class="page-padding col-lg-2 col-md-4 col-sm-6 col-12">' +
            ' <div class="panel panel-block panel-block-sm panel-location">' +
            '<div class="location-header">' +

            ' <h3 class="h4"><img src="img/clients/@location.png"> @name </h3>' +
            '   <i class="zmdi zmdi-check-circle @online"></i>' +
            '   </div>' +
            '  <div class="location-progress">' +
            '      <div class="progress progress-sm">' +
            '       <div class="progress-bar" style="width: @load%;"></div>' +
            '   </div>' +
            '  </div>' +
            ' <ul class="location-info list-styled">' +
            '     <li><span class="list-label">Network @network_rxandnetwork_tx</li>' +
            '     <li><span class="list-label">负载状态:</span> @load%<small>@type</small></li>' +
            '   </ul>' +
            '  </div>' +
            ' </div>';

        var shinnerhtml = '';



        $("#loading-notice").remove();
        if (result.reload)
            setTimeout(function() { location.reload(true) }, 1000);

        for (var i = 0; i < result.location.length; i++) {

            //----kaishi

            // Network
            var newnetstr = "";
            if (result.location[i].network_rx < 1000)
                newnetstr += result.location[i].network_rx.toFixed(0) + "B";
            else if (result.location[i].network_rx < 1000 * 1000)
                newnetstr += (result.location[i].network_rx / 1000).toFixed(0) + "K";
            else
                newnetstr += (result.location[i].network_rx / 1000 / 1000).toFixed(1) + "M";
            newnetstr += " | "
            if (result.location[i].network_tx < 1000)
                newnetstr += result.location[i].network_tx.toFixed(0) + "B";
            else if (result.location[i].network_tx < 1000 * 1000)
                newnetstr += (result.location[i].network_tx / 1000).toFixed(0) + "K";
            else
                newnetstr += (result.location[i].network_tx / 1000 / 1000).toFixed(1) + "M";

            shinnerhtml += shstr.replace("@name", result.location[i].name).replace("@network_rxandnetwork_tx", newnetstr).replace("@type", result.location[i].type).replace("@online", result.location[i].online4 ? 'text-success' : 'text-error').replace("@location", result.location[i].location).replace("@load", result.location[i].load).replace("@load", result.location[i].load);



            //----jieshu


            

            var TableRow = $("#servers tr#r" + i);
            var ExpandRow = $("#servers #rt" + i);
            var hack; // fuck CSS for making me do this
            if (i % 2) hack = "odd";
            else hack = "even";
            if (!TableRow.length) {
                $("#servers").append(
                    "<tr id=\"r" + i + "\" data-toggle=\"collapse\" data-target=\"#rt" + i + "\" class=\"accordion-toggle " + hack + "\">" +
                    "<td style=\"text-align: center;width:4%\" data-title=\"运行状态\" id=\"online4\"><div class=\"progress\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-warning\"><small>加载中</small></div></div></td>" +
                    "<td style=\"width:8%\" data-title=\"节点名\"id=\"name\">加载中</td>" +
                    "<td style=\"width:5%\" data-title=\"类型\"id=\"type\">加载中</td>" +
                    "<!-- td id=\"host\">加载中</td -->" +
                    "<td style=\"width:5%\" data-title=\"服务器位置\"id=\"location\">加载中</td>" +
                    "<td style=\"width:5%\" data-title=\"在线时间\"id=\"uptime\">加载中</td>" +
                    "<td style=\"width:3%\" data-title=\"负载\"id=\"load\">加载中</td>" +
                    "<td style=\"width:4%\" data-title=\"网络(B/s) ↓\"id=\"network_rx\">加载中</td>" +
                    "<td style=\"width:4%\" data-title=\"网络(B/s) ↑\"id=\"network_tx\">加载中</td>" +
                    "<td style=\"width:4%\" data-title=\"流量(B) ↓\"id=\"traffic_in\">加载中</td>" +
                    "<td style=\"width:4%\" data-title=\"流量(B) ↑\"id=\"traffic_out\">加载中</td>" +
                    "<td style=\"width:13%\" data-title=\"内存信息\" id=\"expand_mem\">加载中</td>" +
                    "<td style=\"width:11%\" data-title=\"交换分区\" id=\"expand_swap\">加载中</td>" +
                    "<td style=\"width:11%\" data-title=\"硬盘信息\" id=\"expand_hdd\">加载中</td>" +
                    "<td style=\"width:10%\" data-title=\"IP Addr\" id=\"expand_custom\">加载中</td>" +
                    "<td style=\"width:3%\" data-title=\"CPU\"id=\"cpu\"><div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-warning\"><small>加载中</small></div></div></td>" +
                    "<td style=\"width:3%\" data-title=\"RAM\"id=\"memory\"><div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-warning\"><small>加载中</small></div></div></td>" +
                    "<td style=\"width:3%\" data-title=\"ROM\"id=\"hdd\"><div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-warning\"><small>加载中</small></div></div></td>" +
                    "</tr>"/* +
                    "<tr class=\"expandRow " + hack + "\"><td class=\"ex_info\" colspan=\"13\"><div class=\"accordian-box\"><div class=\"accordian-body collapse\" id=\"rt" + i + "\">" +
                    "<div class=\"col-md-3 mem_text\" id=\"expand_mem\">加载中</div>" +
                    "<div class=\"col-md-3 swap_text\" id=\"expand_swap\">加载中</div>" +
                    "<div class=\"col-md-3 hdd_text\" id=\"expand_hdd\">加载中</div>" +
                    "<div class=\"col-md-3 hdd_text\" id=\"expand_custom\">加载中</div>" +
                    "</div></div></td></tr>"*/
                );
                TableRow = $("#servers tr#r" + i);
                ExpandRow = $("#servers #rt" + i);

                server_status[i] = true;
            }
            TableRow = TableRow[0];
            if (error) {
                TableRow.setAttribute("data-target", "#rt" + i);
                server_status[i] = true;
            }

            // Online4
            if (result.servers[i].online4) {
                TableRow.children["online4"].children[0].children[0].className = "progress-bar progress-bar-success";
                TableRow.children["online4"].children[0].children[0].innerHTML = "<small>运行中</small>";
                up_num++
            } else {
                TableRow.children["online4"].children[0].children[0].className = "progress-bar progress-bar-danger";
                TableRow.children["online4"].children[0].children[0].innerHTML = "<small>维护中</small>";
                down_num++
            }
            document.getElementById("up_num").innerHTML=up_num
            document.getElementById("down_num").innerHTML=down_num
            // Online6
            //if (result.servers[i].online6) {
            //  TableRow.children["online6"].children[0].children[0].className = "progress-bar progress-bar-success";
            //  TableRow.children["online6"].children[0].children[0].innerHTML = "<small>开启</small>";
            //} else {
            //  TableRow.children["online6"].children[0].children[0].className = "progress-bar progress-bar-danger";
            //  TableRow.children["online6"].children[0].children[0].innerHTML = "<small>关闭</small>";
            //}

            // Name
            TableRow.children["name"].innerHTML = result.servers[i].name;

            // Type
            TableRow.children["type"].innerHTML = result.servers[i].type;

            // Host
            //TableRow.children["host"].innerHTML = result.servers[i].host;

            // Location
            TableRow.children["location"].innerHTML = result.servers[i].location;
            if (!result.servers[i].online4 && !result.servers[i].online6) {
                if (server_status[i]) {
                    TableRow.children["uptime"].innerHTML = "–";
                    TableRow.children["load"].innerHTML = "–";
                    TableRow.children["network_rx"].innerHTML = "–";
                    TableRow.children["network_tx"].innerHTML = "–";
                    TableRow.children["traffic_in"].innerHTML = "–";
                    TableRow.children["traffic_out"].innerHTML = "–";
                    TableRow.children["cpu"].children[0].children[0].className = "progress-bar progress-bar-danger";
                    TableRow.children["cpu"].children[0].children[0].style.width = "100%";
                    TableRow.children["cpu"].children[0].children[0].innerHTML = "<small>维护中</small>";
                    TableRow.children["memory"].children[0].children[0].className = "progress-bar progress-bar-danger";
                    TableRow.children["memory"].children[0].children[0].style.width = "100%";
                    TableRow.children["memory"].children[0].children[0].innerHTML = "<small>维护中</small>";
                    TableRow.children["hdd"].children[0].children[0].className = "progress-bar progress-bar-danger";
                    TableRow.children["hdd"].children[0].children[0].style.width = "100%";
                    TableRow.children["hdd"].children[0].children[0].innerHTML = "<small>维护中</small>";
                    if (ExpandRow.hasClass("in")) {
                        ExpandRow.collapse("hide");
                    }
                    TableRow.setAttribute("data-target", "");
                    server_status[i] = false;
                }
            } else {
                if (!server_status[i]) {
                    TableRow.setAttribute("data-target", "#rt" + i);
                    server_status[i] = true;
                }

                // Uptime
                TableRow.children["uptime"].innerHTML = result.servers[i].uptime;

                // Load
                if (result.servers[i].load == -1) {
                    TableRow.children["load"].innerHTML = "–";
                } else {
                    TableRow.children["load"].innerHTML = result.servers[i].load;
                }

                // Network
                var netstr = "";
                if (result.servers[i].network_rx < 1000)
                    netstr = result.servers[i].network_rx.toFixed(0) + "B";
                else if (result.servers[i].network_rx < 1000 * 1000)
                    netstr = (result.servers[i].network_rx / 1000).toFixed(0) + "K";
                else
                    netstr = (result.servers[i].network_rx / 1000 / 1000).toFixed(1) + "M";

                TableRow.children["network_rx"].innerHTML = netstr;

                if (result.servers[i].network_tx < 1000)
                    netstr = result.servers[i].network_tx.toFixed(0) + "B";
                else if (result.servers[i].network_tx < 1000 * 1000)
                    netstr = (result.servers[i].network_tx / 1000).toFixed(0) + "K";
                else
                    netstr = (result.servers[i].network_tx / 1000 / 1000).toFixed(1) + "M";
                TableRow.children["network_tx"].innerHTML = netstr;

                //Traffic
                var trafficstr = "";
                if (result.servers[i].network_in < 1024)
                    trafficstr = result.servers[i].network_in.toFixed(0) + "B";
                else if (result.servers[i].network_in < 1024 * 1024)
                    trafficstr = (result.servers[i].network_in / 1024).toFixed(0) + "K";
                else if (result.servers[i].network_in < 1024 * 1024 * 1024)
                    trafficstr = (result.servers[i].network_in / 1024 / 1024).toFixed(1) + "M";
                else if (result.servers[i].network_in < 1024 * 1024 * 1024 * 1024)
                    trafficstr = (result.servers[i].network_in / 1024 / 1024 / 1024).toFixed(2) + "G";
                else
                    trafficstr = (result.servers[i].network_in / 1024 / 1024 / 1024 / 1024).toFixed(2) + "T";

                TableRow.children["traffic_in"].innerHTML = trafficstr;

                if (result.servers[i].network_out < 1024)
                    trafficstr = result.servers[i].network_out.toFixed(0) + "B";
                else if (result.servers[i].network_out < 1024 * 1024)
                    trafficstr = (result.servers[i].network_out / 1024).toFixed(0) + "K";
                else if (result.servers[i].network_out < 1024 * 1024 * 1024)
                    trafficstr = (result.servers[i].network_out / 1024 / 1024).toFixed(1) + "M";
                else if (result.servers[i].network_out < 1024 * 1024 * 1024 * 1024)
                    trafficstr = (result.servers[i].network_out / 1024 / 1024 / 1024).toFixed(2) + "G";
                else
                    trafficstr = (result.servers[i].network_out / 1024 / 1024 / 1024 / 1024).toFixed(2) + "T";
                TableRow.children["traffic_out"].innerHTML = trafficstr;

                // CPU
                if (result.servers[i].cpu >= 90)
                    TableRow.children["cpu"].children[0].children[0].className = "progress-bar progress-bar-danger";
                else if (result.servers[i].cpu >= 80)
                    TableRow.children["cpu"].children[0].children[0].className = "progress-bar progress-bar-warning";
                else
                    TableRow.children["cpu"].children[0].children[0].className = "progress-bar progress-bar-success";
                TableRow.children["cpu"].children[0].children[0].style.width = result.servers[i].cpu + "%";
                TableRow.children["cpu"].children[0].children[0].innerHTML = "<span>" + result.servers[i].cpu + "%" + "</span>";

                // Memory
                var Mem = ((result.servers[i].memory_used / result.servers[i].memory_total) * 100.0).toFixed(0);
                if (Mem >= 90)
                    TableRow.children["memory"].children[0].children[0].className = "progress-bar progress-bar-danger";
                else if (Mem >= 80)
                    TableRow.children["memory"].children[0].children[0].className = "progress-bar progress-bar-warning";
                else
                    TableRow.children["memory"].children[0].children[0].className = "progress-bar progress-bar-success";
                TableRow.children["memory"].children[0].children[0].style.width = Mem + "%";
                TableRow.children["memory"].children[0].children[0].innerHTML = "<span>" + Mem + "%" + "</span>";
                TableRow.children["expand_mem"].innerHTML = bytesToSize(result.servers[i].memory_used * 1024, 2) + " / " + bytesToSize(result.servers[i].memory_total * 1024, 2);
                // Swap
                TableRow.children["expand_swap"].innerHTML = bytesToSize(result.servers[i].swap_used * 1024, 2) + " / " + bytesToSize(result.servers[i].swap_total * 1024, 2);

                // HDD
                var HDD = ((result.servers[i].hdd_used / result.servers[i].hdd_total) * 100.0).toFixed(0);
                if (HDD >= 90)
                    TableRow.children["hdd"].children[0].children[0].className = "progress-bar progress-bar-danger";
                else if (HDD >= 80)
                    TableRow.children["hdd"].children[0].children[0].className = "progress-bar progress-bar-warning";
                else
                    TableRow.children["hdd"].children[0].children[0].className = "progress-bar progress-bar-success";
                TableRow.children["hdd"].children[0].children[0].style.width = HDD + "%";
                TableRow.children["hdd"].children[0].children[0].innerHTML = HDD + "%";
                TableRow.children["expand_hdd"].innerHTML =  bytesToSize(result.servers[i].hdd_used * 1024 * 1024, 2) + " / " + bytesToSize(result.servers[i].hdd_total * 1024 * 1024, 2);

                // Custom
                if (result.servers[i].custom) {

                    TableRow.children["expand_custom"].innerHTML = result.servers[i].custom.slice(9)
                } else {
                    TableRow.children["expand_custom"].innerHTML = ""
                }
            }
        };
        // console.log(shinnerhtml);
        $('#cards').html(shinnerhtml);
        d = new Date(result.updated * 1000);
        error = 0;
    }).fail(function(update_error) {
        if (!error) {
            $("#servers > tr.accordion-toggle").each(function(i) {
                var TableRow = $("#servers tr#r" + i)[0];
                var ExpandRow = $("#servers #rt" + i);
                TableRow.children["online4"].children[0].children[0].className = "progress-bar progress-bar-error";
                TableRow.children["online4"].children[0].children[0].innerHTML = "<small>错误</small>";
                //TableRow.children["online6"].children[0].children[0].className = "progress-bar progress-bar-error";
                //TableRow.children["online6"].children[0].children[0].innerHTML = "<small>错误</small>";
                TableRow.children["uptime"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["load"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["network_rx"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["network_tx"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["traffic_in"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["traffic_out"].innerHTML = "<div class=\"progress progress-striped active\"><div style=\"width: 100%;\" class=\"progress-bar progress-bar-error\"><small>错误</small></div></div>";
                TableRow.children["cpu"].children[0].children[0].className = "progress-bar progress-bar-error";
                TableRow.children["cpu"].children[0].children[0].style.width = "100%";
                TableRow.children["cpu"].children[0].children[0].innerHTML = "<small>错误</small>";
                TableRow.children["memory"].children[0].children[0].className = "progress-bar progress-bar-error";
                TableRow.children["memory"].children[0].children[0].style.width = "100%";
                TableRow.children["memory"].children[0].children[0].innerHTML = "<small>错误</small>";
                TableRow.children["hdd"].children[0].children[0].className = "progress-bar progress-bar-error";
                TableRow.children["hdd"].children[0].children[0].style.width = "100%";
                TableRow.children["hdd"].children[0].children[0].innerHTML = "<small>错误</small>";
                if (ExpandRow.hasClass("in")) {
                    ExpandRow.collapse("hide");
                }
                TableRow.setAttribute("data-target", "");
                server_status[i] = false;
            });
        }

        error = 1;
        $("#updated").html("更新错误.");
    });
}

function updateTime() {

    if (!error)
        $("#updated").html("最后更新: " + timeSince(d));
}

uptime();
updateTime();
setInterval(uptime, 2000);
setInterval(updateTime, 500);


// styleswitcher.js
function setActiveStyleSheet(title) {
    var i, a, main;
    for (i = 0;
        (a = document.getElementsByTagName("link")[i]); i++) {
        if (a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title")) {
            a.disabled = true;
            if (a.getAttribute("title") == title) a.disabled = false;
        }
    }
}

function getActiveStyleSheet() {
    var i, a;
    for (i = 0;
        (a = document.getElementsByTagName("link")[i]); i++) {
        if (a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled)
            return a.getAttribute("title");
    }
    return null;
}

function getPreferredStyleSheet() {
    var i, a;
    for (i = 0;
        (a = document.getElementsByTagName("link")[i]); i++) {
        if (a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("rel").indexOf("alt") == -1 && a.getAttribute("title"))
            return a.getAttribute("title");
    }
    return null;
}

function createCookie(name, value, days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        var expires = "; expires=" + date.toGMTString();
    } else expires = "";
    document.cookie = name + "=" + value + expires + "; path=/";
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ')
            c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0)
            return c.substring(nameEQ.length, c.length);
    }
    return null;
}

window.onload = function(e) {
    var cookie = readCookie("style");
    var title = cookie ? cookie : getPreferredStyleSheet();
    setActiveStyleSheet(title);
}

window.onunload = function(e) {
    var title = getActiveStyleSheet();
    createCookie("style", title, 365);
}

var cookie = readCookie("style");
var title = cookie ? cookie : getPreferredStyleSheet();
setActiveStyleSheet(title);
